Index: /bidspace/src/main/java/geniusweb/bidspace/BidsWithUtility.java
===================================================================
--- /bidspace/src/main/java/geniusweb/bidspace/BidsWithUtility.java	(revision 52)
+++ /bidspace/src/main/java/geniusweb/bidspace/BidsWithUtility.java	(revision 53)
@@ -3,4 +3,5 @@
 import java.math.BigDecimal;
 import java.math.BigInteger;
+import java.util.Arrays;
 import java.util.Collections;
 import java.util.HashMap;
@@ -39,5 +40,6 @@
 	 */
 	private final Map<Tuple<Integer, Interval>, ImmutableList<Bid>> cache = new HashMap<>();
-	private ImmutableList<Bid> emptylist = new FixedList<>();
+	private ImmutableList<Bid> emptylist = new FixedList<>(
+			Collections.emptyList());
 
 	/**
@@ -176,5 +178,5 @@
 		goal = goal.intersect(getRange(n));
 		if (goal.isEmpty()) {
-			return new FixedList<>();
+			return new FixedList<>(Collections.emptyList());
 		}
 
@@ -220,5 +222,6 @@
 					pbid -> pbid.merge(new Bid(issue, val)), partialbids);
 			if (!fullbids.size().equals(BigInteger.ZERO))
-				fulllist = new JoinedList<Bid>(fullbids, fulllist);
+				fulllist = new JoinedList<Bid>(
+						Arrays.asList(fullbids, fulllist));
 		}
 		return fulllist;
Index: /bidspace/src/main/java/geniusweb/bidspace/PartialSpaceFromUtility.java
===================================================================
--- /bidspace/src/main/java/geniusweb/bidspace/PartialSpaceFromUtility.java	(revision 52)
+++ /bidspace/src/main/java/geniusweb/bidspace/PartialSpaceFromUtility.java	(revision 53)
@@ -3,4 +3,5 @@
 import java.math.BigInteger;
 import java.security.SecureRandom;
+import java.util.Collections;
 import java.util.HashMap;
 import java.util.HashSet;
@@ -24,21 +25,25 @@
 public class PartialSpaceFromUtility extends DefaultPartialOrdering {
 	public PartialSpaceFromUtility(UtilitySpace space, int nRankings) {
-		super(space.getName() + "_" + nRankings, space.getDomain(), space.getReservationBid(),
-				pickBetter(space, nRankings));
+		super(space.getName() + "_" + nRankings, space.getDomain(),
+				space.getReservationBid(), pickBetter(space, nRankings));
 	}
 
 	/**
-	 * Pick subset of static isbetter rankings. Notice, ShuffledList currently can't
-	 * handle really large lists which also limits this. This has to be fixed.
+	 * Pick subset of static isbetter rankings. Notice, ShuffledList currently
+	 * can't handle really large lists which also limits this. This has to be
+	 * fixed.
 	 * 
 	 * @param space     the space to sample from
-	 * @param nRankings the number of rankings to be placed in the PartialOrdering.
+	 * @param nRankings the number of rankings to be placed in the
+	 *                  PartialOrdering.
 	 * @return a subset creating a partial profile of the geiven UtilitySpace
 	 */
-	private static Map<Bid, Set<Bid>> pickBetter(UtilitySpace space, int nRankings) {
+	private static Map<Bid, Set<Bid>> pickBetter(UtilitySpace space,
+			int nRankings) {
 		Map<Bid, Set<Bid>> eqOrBetter = new HashMap<>();
 
 		AllBidsList allbids = new AllBidsList(space.getDomain());
-		ListWithRemove<Tuple<Bid, Bid>> available = new ListWithRemove<>(new Tuples<Bid, Bid>(allbids, allbids));
+		ListWithRemove<Tuple<Bid, Bid>> available = new ListWithRemove<>(
+				new Tuples<Bid, Bid>(allbids, allbids), Collections.emptySet());
 		for (int n = 0; n < nRankings; n++) {
 			BigInteger sel = rnd(available.size());
@@ -79,6 +84,6 @@
 
 	/**
-	 * Bit simplistic way to generate random in [0,n>. Simplistic because the mod()
-	 * operator that we use causes bias in the random numbers.
+	 * Bit simplistic way to generate random in [0,n>. Simplistic because the
+	 * mod() operator that we use causes bias in the random numbers.
 	 * 
 	 * @param n the maximum value for the random number
Index: /bidspace/src/main/java/geniusweb/bidspace/SumOfGroupsLinAdditiveAdapter.java
===================================================================
--- /bidspace/src/main/java/geniusweb/bidspace/SumOfGroupsLinAdditiveAdapter.java	(revision 53)
+++ /bidspace/src/main/java/geniusweb/bidspace/SumOfGroupsLinAdditiveAdapter.java	(revision 53)
@@ -0,0 +1,337 @@
+package geniusweb.bidspace;
+
+import java.math.BigDecimal;
+import java.math.BigInteger;
+import java.math.MathContext;
+import java.math.RoundingMode;
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.List;
+import java.util.Map;
+import java.util.stream.Collectors;
+
+import geniusweb.bidspace.pareto.ParetoLinearAdditive;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.Domain;
+import geniusweb.issuevalue.Value;
+import geniusweb.issuevalue.ValueSet;
+import geniusweb.profile.utilityspace.DiscreteValueSetUtilities;
+import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
+import geniusweb.profile.utilityspace.PartsUtilities;
+import geniusweb.profile.utilityspace.ProductOfValue;
+import geniusweb.profile.utilityspace.SumOfGroupsUtilitySpace;
+import geniusweb.profile.utilityspace.ValueSetUtilities;
+import tudelft.utilities.immutablelist.ArrayListSet;
+
+/**
+ * ValueSet with ProductOfValue objects as elements. Otherwise just a
+ * DiscreteValueSet. Storing the ProductOfValues here directly (instead of
+ * strings) makes it easier to map back and forth
+ *
+ */
+class GroupValueSet implements ValueSet {
+
+	/*
+	 * final, must be immutable so do not provide external access to this list.
+	 * ArrayList (instead of List) to help Jackson serializer which avoids
+	 * per-field type annotations.
+	 */
+	private final ArrayListSet<ProductOfValue> values = new ArrayListSet<>();
+
+	public GroupValueSet(Collection<ProductOfValue> issuevalues) {
+		this.values.addAll(issuevalues);
+	}
+
+	public List<ProductOfValue> getValues() {
+		return Collections.unmodifiableList(values);
+	}
+
+	@Override
+	public Boolean contains(Value value) {
+		return values.contains(value);
+	}
+
+	@Override
+	public ProductOfValue get(BigInteger index) {
+		return values.get(index.intValue());
+	}
+
+	@Override
+	public BigInteger size() {
+		return BigInteger.valueOf(values.size());
+	}
+
+	@Override
+	public ProductOfValue get(long index) {
+		return values.get((int) index);
+	}
+
+	@Override
+	public Iterator iterator() {
+		return values.iterator();
+	}
+
+	@Override
+	public String toString() {
+		return values.toString();
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((values == null) ? 0 : values.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		GroupValueSet other = (GroupValueSet) obj;
+		if (values == null) {
+			if (other.values != null)
+				return false;
+		} else if (!values.equals(other.values))
+			return false;
+		return true;
+	}
+}
+
+/**
+ * As {@link DiscreteValueSetUtilities} but with ProductOfValue instead of Value
+ */
+class GroupValueSetUtilities implements ValueSetUtilities {
+	private final Map<ProductOfValue, BigDecimal> valueUtilities = new HashMap<>();
+
+	public GroupValueSetUtilities(Map<ProductOfValue, BigDecimal> utilities) {
+		valueUtilities.putAll(utilities);
+	}
+
+	@Override
+	public BigDecimal getUtility(Value value) {
+		if (!valueUtilities.containsKey(value)) {
+			return BigDecimal.ZERO;
+		}
+		return valueUtilities.get(value);
+	}
+
+	@Override
+	public String isFitting(ValueSet valueset) {
+		if (!(valueset instanceof GroupValueSet)) {
+			return "The utilities are for a GroupValueSet valueset but the given values are "
+					+ valueset;
+		}
+		GroupValueSet discvalueset = (GroupValueSet) valueset;
+		if (!valueUtilities.keySet()
+				.equals(new HashSet<>(discvalueset.getValues())))
+			return "The values in the set " + valueset
+					+ " do not match the values mapped to utilities "
+					+ valueUtilities.keySet();
+		return null;
+	}
+
+	@Override
+	public String toString() {
+		return valueUtilities.toString();
+	}
+}
+
+/**
+ * Creates a {@link LinearAdditive} profile matching a
+ * {@link SumOfGroupsUtilitySpace}. THe {@link LinearAdditive} can then be used
+ * with tools like {@link ParetoLinearAdditive} or linear parties. Note that
+ * TimeDependentParty and all derivatives use this already and thus seamlessly
+ * support {@link SumOfGroupsUtilitySpace}.
+ * 
+ * <p>
+ * 
+ * The domain, issues values and utilities are all different from the
+ * {@link SumOfGroupsUtilitySpace}. The methods {@link #toLinearBid(Bid)} and
+ * {@link #toGroupBid(Bid)} can be used to convert back and forth. The space is
+ * made such that there is a constant scaling between utilities in the
+ * {@link SumOfGroupsUtilitySpace} and those in the adapted
+ * {@link LinearAdditive} space.
+ * 
+ */
+public class SumOfGroupsLinAdditiveAdapter extends LinearAdditiveUtilitySpace {
+
+	/*
+	 * special character, used as separator char in constructed issue names.
+	 * Must not be used in any original issue names. can be a non-printable
+	 * char, as this class does not serialize but for debugging it's nice to get
+	 * something readable
+	 */
+	private final static String SEP = "~";
+	private final static MathContext mc = new MathContext(10,
+			RoundingMode.DOWN);
+	private static final DiscreteValue WCVALUE = new DiscreteValue("C");
+	private static final ProductOfValue WC = new ProductOfValue(
+			Arrays.asList(WCVALUE));
+	private static final ValueSet WEIGHTCORRECTION = new GroupValueSet(
+			Collections.singletonList(WC));
+	private static final Map<ProductOfValue, BigDecimal> WEIGHTCORRUTIL = Collections
+			.singletonMap(WC, BigDecimal.ZERO);
+
+	private final SumOfGroupsUtilitySpace groupspace;
+
+	/**
+	 * Basically LinearAdditive constructor plus the original group space. Use
+	 * {@link #create(SumOfGroupsUtilitySpace)} to create a
+	 * {@link SumOfGroupsLinAdditiveAdapter}
+	 */
+	private SumOfGroupsLinAdditiveAdapter(SumOfGroupsUtilitySpace groupspace,
+			LinearAdditiveUtilitySpace lin) {
+		super(lin.getDomain(), groupspace.getName(), lin.getUtilities(),
+				lin.getWeights(), lin.getReservationBid());
+		this.groupspace = groupspace;
+	}
+
+	public static SumOfGroupsLinAdditiveAdapter create(
+			SumOfGroupsUtilitySpace groupspace) {
+		checkSpecialCharacter(groupspace);
+
+		final HashMap<String, ValueSetUtilities> linIssueUtilities = new HashMap<>();
+		final HashMap<String, BigDecimal> weights = new HashMap<>();
+		final Map<String, ValueSet> issueValues = new HashMap<>();
+		final BigDecimal SIZE = BigDecimal
+				.valueOf(groupspace.getPartsUtilities().size());
+		final BigDecimal weight = BigDecimal.ONE.divide(SIZE, mc);
+
+		// compute the joned-issue-names, values and utility maps
+		for (final PartsUtilities part : groupspace.getPartsUtilities()
+				.values()) {
+
+			// part is a group, containing a set of issues and
+			// ProductOfValue for every possible combination.
+			final String joinedissue = String.join(SEP, part.getIssues());
+			weights.put(joinedissue, weight);
+
+			issueValues.put(joinedissue,
+					new GroupValueSet(part.getUtilities().keySet()));
+			linIssueUtilities.put(joinedissue,
+					new GroupValueSetUtilities(part.getUtilities()));
+
+		}
+
+		// weight correction. Add issue with name SEP filling the remainder
+		issueValues.put(SEP, WEIGHTCORRECTION);
+		linIssueUtilities.put(SEP, new GroupValueSetUtilities(WEIGHTCORRUTIL));
+		weights.put(SEP, BigDecimal.ONE.subtract(weight.multiply(SIZE)));
+
+		final Domain lindomain = new Domain(groupspace.getDomain().getName(),
+				issueValues);
+		final Bid resbid = toLinearBid(groupspace.getReservationBid(),
+				groupspace);
+		final LinearAdditiveUtilitySpace linspace = new LinearAdditiveUtilitySpace(
+				lindomain, groupspace.getName(), linIssueUtilities, weights,
+				resbid);
+		return new SumOfGroupsLinAdditiveAdapter(groupspace, linspace);
+
+	}
+
+	/**
+	 * Check for occurences of {@link #SEP} in this space.
+	 * 
+	 * @param space2 the space to check
+	 */
+	private static void checkSpecialCharacter(SumOfGroupsUtilitySpace space2) {
+		Domain dom = space2.getDomain();
+		for (String issue : dom.getIssues()) {
+			checkString(issue);
+			for (Value val : dom.getValues(issue)) {
+				if (val instanceof DiscreteValue) {
+					checkString(((DiscreteValue) val).getValue());
+				}
+			}
+		}
+	}
+
+	/**
+	 * check that name does not contain the {@link #SEP} characte to avoid
+	 * problems later. This ensures 1-1 mapping between original names and names
+	 * in converted space.
+	 * 
+	 * @param name the name to check
+	 */
+	private static void checkString(String name) {
+		if (name.contains(SEP))
+			throw new IllegalArgumentException("space should not use  " + name
+					+ " : character '" + SEP + "' is reserved");
+	}
+
+	@Override
+	public String toString() {
+		return "LinearAdditiveAdapter[" + super.toString() + "]";
+	}
+
+	/**
+	 * 
+	 * @param bid
+	 * @param groupspace
+	 * @return bid converted to {@link LinearAdditiveUtilitySpace.
+	 */
+	public static Bid toLinearBid(Bid bid, SumOfGroupsUtilitySpace groupspace) {
+		if (bid == null)
+			return null;
+
+		final Map<String, Value> map = new HashMap<>();
+
+		for (PartsUtilities part : groupspace.getPartsUtilities().values()) {
+			String linissue = String.join(SEP, part.getIssues());
+			List<Value> values = part.getIssues().stream()
+					.map(iss -> bid.getValue(iss)).collect(Collectors.toList());
+			map.put(linissue, new ProductOfValue(values));
+		}
+		return new Bid(map);
+	}
+
+	/**
+	 * 
+	 * @param bid possibly partial {@link Bid} from {@link LinearAdditive} space
+	 * @return a possibly partial Bid in the {@link SumOfGroupsUtilitySpace}.
+	 */
+	public Bid toGroupBid(Bid bid) {
+		if (bid == null)
+			return null;
+
+		final Map<String, Value> allvalues = new HashMap<>();
+
+		for (String linissue : bid.getIssues()) {
+			allvalues.putAll(toGroupValues(linissue,
+					(ProductOfValue) bid.getValue(linissue)));
+		}
+		return new Bid(allvalues);
+	}
+
+	/**
+	 * 
+	 * @param linissue an issue in the {@link LinearAdditive} space
+	 * @param value    a value in the {@link LinearAdditive} space
+	 * @return a map of issue-value pairs in the {@link SumOfGroupsUtilitySpace}
+	 */
+	private Map<String, Value> toGroupValues(String linissue,
+			ProductOfValue value) {
+		if (linissue.equals(SEP))
+			// ignore the weight-balancer issue
+			return Collections.emptyMap();
+
+		final Map<String, Value> values = new HashMap<>();
+		final String[] issues = linissue.split(SEP);
+		for (int n = 0; n < issues.length; n = n + 1) {
+			values.put(issues[n], value.getValues().get(n));
+		}
+
+		return values;
+	}
+}
Index: /bidspace/src/test/java/geniusweb/bidspace/SumOfGroupsLinAdditiveAdapterTest.java
===================================================================
--- /bidspace/src/test/java/geniusweb/bidspace/SumOfGroupsLinAdditiveAdapterTest.java	(revision 53)
+++ /bidspace/src/test/java/geniusweb/bidspace/SumOfGroupsLinAdditiveAdapterTest.java	(revision 53)
@@ -0,0 +1,93 @@
+package geniusweb.bidspace;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.math.BigInteger;
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.Random;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.Value;
+import geniusweb.profile.utilityspace.ProductOfValue;
+import geniusweb.profile.utilityspace.SumOfGroupsUtilitySpace;
+
+public class SumOfGroupsLinAdditiveAdapterTest {
+	private final ObjectMapper jackson = new ObjectMapper();
+	private final Random random = new Random();
+	private final SumOfGroupsLinAdditiveAdapter adapter;
+	private final SumOfGroupsUtilitySpace groupspace;
+
+	public SumOfGroupsLinAdditiveAdapterTest()
+			throws JsonParseException, JsonMappingException, IOException {
+		groupspace = jackson.readValue(
+				getClass().getResourceAsStream("/computer/computerbuy.json"),
+				SumOfGroupsUtilitySpace.class);
+		adapter = SumOfGroupsLinAdditiveAdapter.create(groupspace);
+
+	}
+
+	@Test
+	public void smokeTest() {
+		System.out.println("" + adapter);
+	}
+
+	@Test
+	public void checkUtility() throws IOException {
+		AllBidsList bidspace = new AllBidsList(groupspace.getDomain());
+		int NISS = adapter.getDomain().getIssues().size() - 1;
+
+		// compare utility of many random bids
+		for (int n = 0; n < 100; n += 1) {
+			// space is small, do this simple
+
+			int i = random.nextInt(bidspace.size().intValue());
+			// this is bid in the group space.
+			Bid groupbid = bidspace.get(BigInteger.valueOf(i));
+
+			Bid linbid = adapter.toLinearBid(groupbid, groupspace);
+
+			assertEquals(groupspace.getUtility(groupbid).floatValue(),
+					NISS * adapter.getUtility(linbid).floatValue(), 0.000001);
+
+			assertEquals(groupbid, adapter.toGroupBid(linbid));
+		}
+	}
+
+	@Test
+	public void checkReservationBid() {
+		assertEquals(groupspace.getReservationBid(),
+				adapter.toGroupBid(adapter.getReservationBid()));
+	}
+
+	@Test
+	public void testGroupValueSet() {
+		final Value val1 = new DiscreteValue("val1");
+		final ProductOfValue pov = new ProductOfValue(Arrays.asList(val1));
+		final Collection<ProductOfValue> issuevalues = Arrays.asList(pov);
+		final GroupValueSet gvs = new GroupValueSet(issuevalues);
+		final GroupValueSet gvs1 = new GroupValueSet(issuevalues);
+
+		assertEquals(issuevalues, gvs.getValues());
+		assertEquals(BigInteger.ONE, gvs.size());
+		assertEquals(pov, gvs.get(BigInteger.ZERO));
+		assertEquals(pov, gvs.get(0));
+		assertEquals(pov, gvs.iterator().next());
+		assertEquals("[" + pov + "]", gvs.toString());
+
+		// poor man's GenericTests, we can't do GenericTests because that's on a
+		// class level
+		// and we can't make a class level test here.
+		assertEquals(gvs, gvs);
+		assertEquals(gvs1, gvs);
+		assertEquals(gvs.hashCode(), gvs1.hashCode());
+	}
+}
Index: /bidspace/src/test/java/geniusweb/bidspace/pareto/ParetoRandomTest.java
===================================================================
--- /bidspace/src/test/java/geniusweb/bidspace/pareto/ParetoRandomTest.java	(revision 53)
+++ /bidspace/src/test/java/geniusweb/bidspace/pareto/ParetoRandomTest.java	(revision 53)
@@ -0,0 +1,136 @@
+package geniusweb.bidspace.pareto;
+
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.commons.math.stat.descriptive.DescriptiveStatistics;
+import org.junit.Test;
+
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.DiscreteValueSet;
+import geniusweb.issuevalue.Domain;
+import geniusweb.issuevalue.ValueSet;
+import geniusweb.profile.utilityspace.DiscreteValueSetUtilities;
+import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
+import geniusweb.profile.utilityspace.ValueSetUtilities;
+
+/**
+ * Test pareto on random space.
+ */
+public class ParetoRandomTest {
+
+	private final int DIMENSION = 2; // #participants. 2 is normal bilateral
+										// space
+	private final int NISSUES = 3; // number of issues
+	private final int NVALS = 10; // number values per issue
+	private final int NRUNS = 50; // number of runs (to average result)
+
+	@Test
+	public void checkGenerciPareto() throws IOException {
+
+		DescriptiveStatistics time = new DescriptiveStatistics();
+		DescriptiveStatistics paretopoints = new DescriptiveStatistics();
+
+		for (int run = 0; run < NRUNS; run++) {
+			System.gc(); // free memory before each test run
+			System.out.print(".");
+			long startTime = System.nanoTime();
+			ParetoLinearAdditive pareto = runOneTest();
+			paretopoints.addValue(pareto.getPoints().size());
+
+			double dt = (System.nanoTime() - startTime) / 1000000000d;
+
+			time.addValue(dt);
+		}
+		System.out.println();
+		System.out.println("Results averaged over " + NRUNS + " runs");
+		System.out.println("DIMENSION=" + DIMENSION);
+		System.out.println("NISSUES=" + NISSUES);
+		System.out.println("NVALS=" + NVALS);
+		System.out.println("bidspace=" + Math.pow(NVALS, NISSUES));
+		System.out.println("runtime: " + time.getMean() + "s, stdev="
+				+ time.getStandardDeviation());
+		System.out.println("points on pareto: " + paretopoints.getMean()
+				+ ", stdev=" + paretopoints.getStandardDeviation());
+		System.out.println("{" + DIMENSION + "," + NISSUES + "," + NVALS + ","
+				+ time.getMean() + "," + time.getStandardDeviation() + ","
+				+ paretopoints.getMean() + ","
+				+ paretopoints.getStandardDeviation() + "}");
+	}
+
+	private ParetoLinearAdditive runOneTest() {
+		Domain domain = getRandomDomain();
+
+		List<LinearAdditive> profiles = new LinkedList<>();
+		for (int n = 0; n < DIMENSION; n++) {
+			LinearAdditiveUtilitySpace rspace = getRandomSpace(domain);
+			profiles.add(rspace);
+		}
+		return new ParetoLinearAdditive(profiles);
+
+	}
+
+	private Domain getRandomDomain() {
+		Map<String, ValueSet> issues = new HashMap<>();
+		List<BigDecimal> w = getRandomWeights();
+		for (int iss = 0; iss < NISSUES; iss++) {
+			Collection<DiscreteValue> values = new LinkedList<>();
+			for (int val = 0; val < NVALS; val++) {
+				DiscreteValue v = new DiscreteValue("iss" + iss + "val" + val);
+				values.add(v);
+			}
+			String issuename = "issue" + iss;
+			issues.put(issuename, new DiscreteValueSet(values));
+
+		}
+		return new Domain("dom", issues);
+	}
+
+	/**
+	 * 
+	 * @param domain some domain with discrete issue values
+	 * @return random LA utilspace for this domain
+	 */
+	private LinearAdditiveUtilitySpace getRandomSpace(Domain domain) {
+		List<String> issuelist = new LinkedList(domain.getIssues());
+		Map<String, ValueSetUtilities> utils = new HashMap<>();
+		Map<String, BigDecimal> weights = new HashMap<>();
+		List<BigDecimal> w = getRandomWeights();
+		for (int iss = 0; iss < NISSUES; iss++) {
+			String issuename = issuelist.get(iss);
+			Map<DiscreteValue, BigDecimal> utilsmap = new HashMap<>();
+			for (int val = 0; val < NVALS; val++) {
+				DiscreteValue v = (DiscreteValue) domain.getValues(issuename)
+						.get(val);
+				utilsmap.put(v, BigDecimal.valueOf(Math.random()));
+			}
+			weights.put(issuename, w.get(iss));
+			utils.put(issuename, new DiscreteValueSetUtilities(utilsmap));
+		}
+		return new LinearAdditiveUtilitySpace(domain, "name", utils, weights,
+				null);
+	}
+
+	/**
+	 * 
+	 * @return list of NISSUES BigDecimals, summing to 1
+	 */
+	private List<BigDecimal> getRandomWeights() {
+		List<BigDecimal> doubles = new LinkedList<>();
+		BigDecimal remainder = BigDecimal.ONE;
+		for (int n = 0; n < NISSUES - 1; n++) {
+			BigDecimal next = BigDecimal.valueOf(Math.random() / NISSUES);
+			doubles.add(next);
+			remainder = remainder.subtract(next);
+		}
+		doubles.add(remainder);
+		return doubles;
+	}
+
+}
Index: /collectparties.sh
===================================================================
--- /collectparties.sh	(revision 52)
+++ /collectparties.sh	(revision 53)
@@ -7,5 +7,5 @@
 rm -rf collectedparties
 mkdir collectedparties
-VERSION=2.1.6
+VERSION=2.2.1
 
 cp "exampleparties/anac2019/agentgg/target/agentgg-${VERSION}-jar-with-dependencies.jar" collectedparties
Index: /domaineditor/src/main/java/geniusweb/domaineditor/ProfileEditor.java
===================================================================
--- /domaineditor/src/main/java/geniusweb/domaineditor/ProfileEditor.java	(revision 52)
+++ /domaineditor/src/main/java/geniusweb/domaineditor/ProfileEditor.java	(revision 53)
@@ -15,4 +15,6 @@
 import geniusweb.domaineditor.panels.profile.ProfileEditorPanel;
 import tudelft.utilities.logging.Reporter;
+import tudelft.utilities.mvc.model.ModelTime;
+import tudelft.utilities.mvc.model.NoModelTime;
 import tudelft.utilities.mvc.panels.PopupReporter;
 
@@ -24,4 +26,6 @@
 @SuppressWarnings("serial")
 public class ProfileEditor extends JFrame {
+	public static ModelTime TIME = new NoModelTime();
+
 	private final Reporter log;
 	private final LinearAdditiveUtilitySpaceModel model;
Index: /domaineditor/src/main/java/geniusweb/domaineditor/model/BidModel.java
===================================================================
--- /domaineditor/src/main/java/geniusweb/domaineditor/model/BidModel.java	(revision 52)
+++ /domaineditor/src/main/java/geniusweb/domaineditor/model/BidModel.java	(revision 53)
@@ -7,9 +7,11 @@
 import java.util.logging.Level;
 
+import geniusweb.domaineditor.ProfileEditor;
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.DiscreteValue;
 import geniusweb.issuevalue.NumberValue;
 import geniusweb.issuevalue.Value;
-import tudelft.utilities.listener.DefaultListenable;
+import tudelft.utilities.listener.DefaultThrowingListenable;
+import tudelft.utilities.listener.Unacceptable;
 import tudelft.utilities.logging.Reporter;
 import tudelft.utilities.mvc.model.BasicModel;
@@ -18,7 +20,8 @@
 import tudelft.utilities.mvc.model.MapFromKeys;
 import tudelft.utilities.mvc.model.MapModel;
+import tudelft.utilities.mvc.model.Model;
+import tudelft.utilities.mvc.model.ModelTime;
 import tudelft.utilities.mvc.model.SelectionModel;
 import tudelft.utilities.mvc.model.StringModel;
-import tudelft.utilities.mvc.model.TypedModel;
 import tudelft.utilities.mvc.model.events.Added;
 import tudelft.utilities.mvc.model.events.Changed;
@@ -38,6 +41,6 @@
  *
  */
-public class BidModel extends DefaultListenable<Event> implements
-		MapModel<StringModel, SelectionModel<BasicModel>>, TypedModel<Bid> {
+public class BidModel extends DefaultThrowingListenable<Event>
+		implements MapModel<StringModel, SelectionModel<BasicModel>>, Model {
 	private final MapModel<StringModel, ValueSetModel> issuevalues;
 	private final Map<StringModel, SelectionModel<BasicModel>> selections = new HashMap<>();
@@ -66,17 +69,17 @@
 
 	private void add(StringModel key, ListModel value) {
-		selections.put(key, new DefaultSelectionModel(value));
+		selections.put(key, new DefaultSelectionModel(value, log, true));
 	}
 
 	/**
 	 * Domain change occured. Handle it.
+	 * 
+	 * @throws Unacceptable
 	 */
-	private void handleChange(Event e) {
+	private void handleChange(Event e) throws Unacceptable {
 		// we only handle add/remove of issues. If a value is removed,
 		// this should automatically reflect into the selectionmodel.
-		if (!(e instanceof Changed)) {
-			System.out.println("Unexpected event " + e);
-			return;
-		}
+		if (!(e instanceof Changed))
+			throw new Unacceptable("Unexpected event " + e);
 		e = e.getChildEvent();
 		if (e instanceof Removed) {
@@ -101,5 +104,4 @@
 	}
 
-	@Override
 	public void remove(StringModel key) {
 		throw new UnsupportedOperationException();
@@ -121,5 +123,4 @@
 	}
 
-	@Override
 	public Bid getCurrentValue() throws IllegalStateException {
 		Map<String, Value> selectionmap = new HashMap<>();
@@ -134,5 +135,4 @@
 	}
 
-	@Override
 	public void setCurrentValue(Bid bid) throws IllegalArgumentException {
 		ListModel<StringModel> issues = issuevalues.getKeys();
@@ -186,3 +186,8 @@
 	}
 
+	@Override
+	public ModelTime getTime() {
+		return ProfileEditor.TIME;
+	}
+
 }
Index: /domaineditor/src/main/java/geniusweb/domaineditor/model/DiscreteValueSetModel.java
===================================================================
--- /domaineditor/src/main/java/geniusweb/domaineditor/model/DiscreteValueSetModel.java	(revision 52)
+++ /domaineditor/src/main/java/geniusweb/domaineditor/model/DiscreteValueSetModel.java	(revision 53)
@@ -7,4 +7,5 @@
 import java.util.logging.Level;
 
+import geniusweb.domaineditor.ProfileEditor;
 import geniusweb.issuevalue.DiscreteValue;
 import geniusweb.issuevalue.DiscreteValueSet;
@@ -25,9 +26,10 @@
 
 	public DiscreteValueSetModel(List<StringModel> values, Reporter log) {
-		super(values, log);
+		super(values, log, ProfileEditor.TIME);
 	}
 
 	public DiscreteValueSetModel(Reporter log) {
-		super(Arrays.asList(new StringModel("value", log)), log);
+		super(Arrays.asList(new StringModel("value", log, ProfileEditor.TIME)),
+				log, ProfileEditor.TIME);
 	}
 
@@ -78,5 +80,5 @@
 		// first add the new vals because minimum size.
 		for (DiscreteValue val : valset.getValues()) {
-			add(new StringModel(val.getValue(), log));
+			add(new StringModel(val.getValue(), log, ProfileEditor.TIME));
 		}
 		for (StringModel old : oldvals) {
Index: /domaineditor/src/main/java/geniusweb/domaineditor/model/DomainModel.java
===================================================================
--- /domaineditor/src/main/java/geniusweb/domaineditor/model/DomainModel.java	(revision 52)
+++ /domaineditor/src/main/java/geniusweb/domaineditor/model/DomainModel.java	(revision 53)
@@ -16,11 +16,11 @@
 import geniusweb.issuevalue.Domain;
 import geniusweb.issuevalue.ValueSet;
-import tudelft.utilities.listener.DefaultListenable;
+import tudelft.utilities.listener.DefaultThrowingListenable;
 import tudelft.utilities.logging.Reporter;
 import tudelft.utilities.mvc.model.DefaultMapModel;
 import tudelft.utilities.mvc.model.MapModel;
 import tudelft.utilities.mvc.model.Model;
+import tudelft.utilities.mvc.model.ModelTime;
 import tudelft.utilities.mvc.model.StringModel;
-import tudelft.utilities.mvc.model.TypedModel;
 import tudelft.utilities.mvc.model.events.Changed;
 import tudelft.utilities.mvc.model.events.Event;
@@ -33,6 +33,6 @@
  *
  */
-public class DomainModel extends DefaultListenable<Event>
-		implements TypedModel<Domain> {
+public class DomainModel extends DefaultThrowingListenable<Event>
+		implements Model { // model<Domain>
 	private static final ObjectMapper jackson = new ObjectMapper();
 	private final StringModel domainname;
@@ -57,7 +57,9 @@
 		this(new SimpleStringModel("domainname", log),
 				new DefaultMapModel<StringModel, ValueSetModel>(
-						Collections.singletonMap(new StringModel("issue", log),
+						Collections.singletonMap(
+								new StringModel("issue", log,
+										ProfileEditor.TIME),
 								new DiscreteValueSetModel(log)),
-						log) {
+						log, ProfileEditor.TIME) {
 					@Override
 					public int getMinimumSize() {
@@ -88,6 +90,7 @@
 		Domain domain = jackson.readValue(file, Domain.class);
 		// FIXME
-		return new DomainModel(new StringModel(domain.getName(), log), null,
-				log);
+		return new DomainModel(
+				new StringModel(domain.getName(), log, ProfileEditor.TIME),
+				null, log);
 	}
 
@@ -112,5 +115,4 @@
 	 * @return the {@link Domain} contained in this model.
 	 */
-	@Override
 	public Domain getCurrentValue() throws IllegalStateException {
 		Map<String, ValueSet> issues = new HashMap<>();
@@ -131,5 +133,4 @@
 	 *            {@link Model}s are created where needed.
 	 */
-	@Override
 	public void setCurrentValue(Domain dom) throws IllegalArgumentException {
 		domainname.setValue(dom.getName());
@@ -145,9 +146,15 @@
 					ValueSetModelType.fromModel(dom.getValues(iss)), log);
 			valsetmodel.setCurrentValue(dom.getValues(iss));
-			issuesmodel.put(new StringModel(iss, log), valsetmodel);
+			issuesmodel.put(new StringModel(iss, log, ProfileEditor.TIME),
+					valsetmodel);
 		}
 		// remove the old issues
 		for (StringModel iss : oldissues)
-			issuesmodel.remove(iss);
+			issuesmodel.getKeys().remove(iss);
+	}
+
+	@Override
+	public ModelTime getTime() {
+		return ProfileEditor.TIME;
 	}
 }
